<template>
    <div class="header row items-center q-pl-sm">
        <q-btn @click="closePreview" flat round color="black" icon="close" />
        {{ $t('button.preview') }}
    </div>
    <q-tab-panels class="content col" v-model="selectedIndex" animated>
        <q-tab-panel
            v-for="(fileModel, index) in fileList"
            :key="index"
            :name="index"
            class="column"
        >
            <!-- Image -->
            <div
                v-if="fileModel.type == MessageType.IMAGE"
                class="col column justify-center items-center"
            >
                <img :src="fileModel.url" class="w-100" />
            </div>

            <!-- Video -->
            <div
                v-else-if="fileModel.type == MessageType.VIDEO"
                class="col column justify-center items-center w-100"
            >
                <video
                    :src="fileModel.url"
                    :autoplay="false"
                    controls
                    class="w-100 h-100"
                />
            </div>

            <!-- Audio -->
            <div
                v-else-if="fileModel.type == MessageType.AUDIO"
                class="col column justify-center items-center"
            >
                <audio :src="fileModel.url" :autoplay="false" controls />
            </div>

            <!-- Gif -->
            <div
                v-else-if="fileModel.type == MessageType.GIF"
                class="col column justify-center items-center w-100"
            >
                <img :src="fileModel.url" />
            </div>

            <!-- File -->
            <div v-else class="col column justify-center items-center">
                <q-icon name="mdi-file-outline" size="60px" />
                <span class="name q-mt-sm">
                    {{ fileModel.file?.name ?? '' }}
                </span>
            </div>
        </q-tab-panel>
    </q-tab-panels>
    <footer-section
        v-if="isShowFooter"
        :key="selectedIndex"
        :initialText="fileList[selectedIndex]?.text ?? ''"
        :isPreview="true"
        @gifSelected="onGifSelected"
        @submit="onSubmit"
        @textChanged="onTextChanged"
    />
    <q-scroll-area
        class="slider"
        :content-style="{
            'flex-direction': 'column',
            display: 'flex'
        }"
    >
        <div class="slider-content row inline no-wrap">
            <div
                v-for="(fileModel, index) in fileList"
                :key="index"
                class="slider-item column justify-center items-center"
                @click="selectedIndex = index"
                :class="selectedIndex == index ? 'active' : ''"
            >
                <!-- Image -->
                <div
                    v-if="fileModel.type == MessageType.IMAGE"
                    class="column justify-center items-center"
                >
                    <img :src="fileModel.url" class="item" />
                </div>

                <!-- Video -->
                <div
                    v-else-if="fileModel.type == MessageType.VIDEO"
                    class="column justify-center items-center"
                >
                    <video
                        :src="fileModel.url"
                        :autoplay="false"
                        :muted="true"
                        preload="metadata"
                        :controls="false"
                        style="width: 100px; height: 100px; object-fit: cover"
                    />
                </div>

                <!-- Audio -->
                <div
                    v-else-if="fileModel.type == MessageType.AUDIO"
                    class="column justify-center items-center"
                >
                    <q-icon name="music_note" size="30px" />
                    <small class="name q-mt-sm">
                        {{ fileModel.file?.name ?? '' }}
                    </small>
                </div>

                <!-- Gif -->
                <div
                    v-else-if="fileModel.type == MessageType.GIF"
                    class="column justify-center items-center"
                >
                    <q-img
                        no-spinner
                        unelevated
                        cover
                        :src="fileModel.previewUrl ?? fileModel.url"
                        :width="`100px`"
                        :height="`100px`"
                    />
                </div>

                <!-- File -->
                <div v-else class="column justify-center items-center">
                    <q-icon name="mdi-file-outline" size="30px" />
                    <small class="name q-mt-sm">
                        {{ fileModel.file?.name ?? '' }}
                    </small>
                </div>

                <q-btn
                    @click="removeItem(index)"
                    unelevated
                    round
                    icon="close"
                    class="slider-close-btn"
                    size="5px"
                />
            </div>
        </div>
    </q-scroll-area>
    <q-btn
        v-if="!isShowFooter"
        class="fab"
        fab
        color="primary"
        @click="onSubmit"
    >
        <q-icon v-if="!isLoading" name="done" />
        <q-spinner-dots v-else color="white" />
    </q-btn>
</template>

<style lang="scss" scoped>
.fab {
    position: absolute;
    bottom: 100px;
    right: 10%;
    z-index: 9999;
}
.slider {
    padding-left: 15px;

    .q-tab-panels {
        background: unset;
    }

    .name {
        width: 100%;
        white-space: nowrap;
        text-overflow: ellipsis;
        overflow: hidden;
        text-align: center;
    }

    .slider-content {
        .slider-item {
            cursor: pointer;
            height: 65px;
            width: 65px;
            margin: 5px;
            position: relative;
            background-color: #f0f6fe;
            -webkit-transition: all 0.1s ease-in-out;
            -moz-transition: all 0.1s ease-in-out;
            transition: all 0.1s ease-in-out;

            &:hover {
                transform: scale(1.05);
            }

            .q-btn {
                position: absolute;
                top: -5px;
                right: -5px;
                -webkit-transition: all 0.1s ease-in-out;
                -moz-transition: all 0.1s ease-in-out;
                transition: all 0.1s ease-in-out;
                background-color: #ff6700;
                color: white;

                &:hover {
                    transform: scale(1.3);
                }
            }

            .name {
                width: 100px;
                padding-left: 10px;
                padding-right: 10px;
            }

            .item {
                width: 100%;
                max-height: 65px;
            }
        }

        .slider-item.active {
            border: 2px solid #ff6700;
        }
    }
}
</style>

<script lang="ts">
import { defineComponent, toRef, ref, onMounted, computed } from 'vue';
import { FilePreview } from 'src/services/models/FilePreview';
import { MessageType } from 'src/services/enums/MessageType';
import { MessageCreateRequestBody } from 'src/services/requests/message/MessageCreateRequest';
import generateRandomString from 'src/services/helpers/GenerateRandomString';
import { Conversation } from 'src/services/models/Conversation';
import { useStore } from 'src/store';
import { Message } from 'src/services/models/Message';
import { debounce } from 'quasar';
import Footer from 'src/components/chats/Footer.vue';

export default defineComponent({
    name: 'PreviewUpload',
    components: {
        'footer-section': Footer
    },
    emits: ['close', 'submit', 'update'],
    props: {
        files: {
            type: Object as () => FilePreview[],
            required: true
        }
    },
    setup(props, { emit }) {
        const store = useStore();
        const fileList = toRef(props, 'files');
        const selectedIndex = ref(0);
        const isLoading = ref(false);
        const conversation = computed<Conversation>(
            () => store.state.chat.selectedConversation as Conversation
        );
        const replyToMessage = computed(
            (): Message => store.state.chat.replyToMessage as Message
        );

        onMounted(() => {
            if (fileList.value.length) {
                selectedIndex.value = fileList.value.length - 1;
            }
        });

        const removeItem = (index: number) => {
            // Close if last item is removed
            if (fileList.value.length == 1) {
                emit('update', []);
                emit('close');
                return;
            }

            // Remove file from array
            fileList.value.splice(index, 1);

            // Update the list
            emit('update', fileList.value);
        };

        const closePreview = () => {
            store.dispatch('chat/removeReply');
            emit('update', []);
            emit('close');
        };

        const isShowFooter = computed(() => {
            return (
                (fileList.value[selectedIndex.value] &&
                    fileList.value[selectedIndex.value].type !=
                        MessageType.DOCUMENT &&
                    fileList.value[selectedIndex.value].type !=
                        MessageType.AUDIO) ??
                false
            );
        });

        const onGifSelected = (gif: FilePreview) => {
            // Limit GIF to 10 only at one time
            if (fileList.value.length < 10) {
                gif.text = '';
                fileList.value.push({
                    ...gif,
                    type: MessageType.GIF
                });

                // Update the list
                emit('update', fileList.value);
            }
        };

        const onSubmit = debounce(() => {
            if (isLoading.value) {
                return;
            }

            isLoading.value = true;
            Promise.all(
                fileList.value.map(async (fileModel) => {
                    // Get mentionedUserIdsÎ
                    let newText = fileModel.text;
                    let match;
                    let mentionedUserIds: string[] = [];

                    if (newText) {
                        const mentionRegex = new RegExp(/\[\@(.+?)\@\]/gim);
                        while (null != (match = mentionRegex.exec(newText))) {
                            if (match[1] != 'all') {
                                mentionedUserIds.push(match[1]);
                            }
                        }
                    }

                    // Create message body
                    const body: MessageCreateRequestBody = {
                        conversationId:
                            store.state.conversation.selectedConversationID,
                        type: fileModel.type,
                        text: newText?.trim(),
                        createdAt: new Date(),
                        localId: generateRandomString(24),
                        mentionedUserIds
                    };

                    // Handle virgin conversation without ID
                    if (conversation.value?.id == conversation.value?.userId) {
                        body.userId = conversation.value?.userId;
                    } else {
                        body.conversationId = conversation.value?.id;
                    }

                    // Handle reply
                    if (replyToMessage.value) {
                        body.repliedMessageId = replyToMessage.value.id;
                    }

                    // Handle audio type
                    if (fileModel.type == MessageType.AUDIO) {
                        body.type = MessageType.DOCUMENT;
                        body.text = fileModel.file?.name;
                    }

                    // Handle other type
                    if (fileModel.type == MessageType.DOCUMENT) {
                        body.text = fileModel.file?.name;
                    }

                    // Handle gif type
                    if (fileModel.type == MessageType.GIF) {
                        body.gifUrl = fileModel.url;
                        body.gifDimension = `${fileModel?.width ?? ''}x${
                            fileModel?.height ?? ''
                        }`;

                        // Send to API
                        store.dispatch('message/sendMessage', {
                            body,
                            repliedMessage: replyToMessage.value
                        });
                    }

                    // Upload the file if needed
                    else {
                        // Create message template first
                        store.dispatch('message/sendMessage', {
                            body,
                            file: {
                                path: fileModel.url,
                                url: fileModel.url
                            },
                            thumbnail: {
                                path: fileModel.url,
                                url: fileModel.url
                            },
                            repliedMessage: replyToMessage.value,
                            silent: true
                        });

                        const file: { url: string; path: string } =
                            await store.dispatch('file/upload', {
                                file: fileModel.file,
                                thumbnail: true
                            });

                        if (file.url) {
                            body.filePath = file.path;

                            if (
                                fileModel.type == MessageType.IMAGE ||
                                fileModel.type == MessageType.VIDEO
                            ) {
                                body.thumbnailPath = file.path;
                            }

                            // Send to API
                            store.dispatch('message/sendMessage', {
                                body: body,
                                file: file,
                                repliedMessage: replyToMessage.value
                            });
                        }
                    }
                })
            );
            isLoading.value = false;

            store.dispatch('chat/removeReply');
            emit('update', []);
            emit('close');
        }, 200);

        const onTextChanged = (newText: string) => {
            fileList.value[selectedIndex.value].text = newText;
        };

        return {
            fileList,
            selectedIndex,
            removeItem: debounce(removeItem, 1000, true),
            closePreview: debounce(closePreview, 1000, true),
            isShowFooter,
            MessageType,
            onGifSelected,
            onSubmit,
            onTextChanged,
            isLoading
        };
    }
});
</script>
